/* ========================================
 *
 
 *
 * ========================================
*/



#include <DMA.h>
#include <RMS.h>        // NO_SAMPLES, Buffer




//==============================================================================
// DMA1 configuration (4 TDs)
//==============================================================================
void DMA1_Config(void)
{
    uint8 DMA1_Chan;
    uint8 DMA1_TD[4];
    
    #define TRANSFER_COUNT          (NO_SAMPLES * 2)    
    #define BUFFER_1                (NO_SAMPLES)
    #define BUFFER_2                (NO_SAMPLES * 2)
    #define BUFFER_3                (NO_SAMPLES * 3)

    #define DMA_BYTES_PER_BURST     (2u)
    #define DMA_REQUEST_PER_BURST   (1u)
    #define DMA_SRC_BASE            (CYDEV_PERIPH_BASE)
    #define DMA_DST_BASE            (CYDEV_SRAM_BASE)

	DMA1_Chan = DMA1_DmaInitialize(DMA_BYTES_PER_BURST, DMA_REQUEST_PER_BURST, HI16(DMA_SRC_BASE), HI16(DMA_DST_BASE));
	DMA1_TD[0] = CyDmaTdAllocate();
	DMA1_TD[1] = CyDmaTdAllocate();
	DMA1_TD[2] = CyDmaTdAllocate();
	DMA1_TD[3] = CyDmaTdAllocate();
    
    CyDmaTdSetConfiguration(DMA1_TD[0], TRANSFER_COUNT, DMA1_TD[1], DMA1__TD_TERMOUT_EN | TD_INC_DST_ADR);   
 	CyDmaTdSetConfiguration(DMA1_TD[1], TRANSFER_COUNT, DMA1_TD[2], DMA1__TD_TERMOUT_EN | TD_INC_DST_ADR);
    CyDmaTdSetConfiguration(DMA1_TD[2], TRANSFER_COUNT, DMA1_TD[3], DMA1__TD_TERMOUT_EN | TD_INC_DST_ADR);   
 	CyDmaTdSetConfiguration(DMA1_TD[3], TRANSFER_COUNT, DMA1_TD[0], DMA1__TD_TERMOUT_EN | TD_INC_DST_ADR);
    
    // Target 
    CyDmaTdSetAddress(DMA1_TD[0], LO16((uint32)ADC_1_DEC_SAMP_PTR), LO16((uint32)(&Buffer[0])));
    CyDmaTdSetAddress(DMA1_TD[1], LO16((uint32)ADC_1_DEC_SAMP_PTR), LO16((uint32)(&Buffer[BUFFER_1])));
    CyDmaTdSetAddress(DMA1_TD[2], LO16((uint32)ADC_1_DEC_SAMP_PTR), LO16((uint32)(&Buffer[BUFFER_2]))); 
    CyDmaTdSetAddress(DMA1_TD[3], LO16((uint32)ADC_1_DEC_SAMP_PTR), LO16((uint32)(&Buffer[BUFFER_3]))); 

	CyDmaChSetInitialTd(DMA1_Chan, DMA1_TD[0]);
	CyDmaChEnable(DMA1_Chan, 1);// Enable DMA channel
}


/* [] END OF FILE */
