/* ============================================================================
 * Library Name: StopWatch
 * Version 0.0 build 01d
 *
 * Description:
 *   24-bit timer to measure interval between Start and Stop calls.
 *   Uses system timer (SysTick) to count elapsed system clocks.
 *   Operates at system clock rate.
 *   Maximum measured value without overloading is 0xFFFF
 *   Can be used for time-profiling of project code or as a spare timer
 *   on systems with limited resources.
 *   Tested using PSoC5LP and PSoC4 
 *
 * Credits:
 *
 * Note:
 *   Due to use of the system timer only a single instance of the component
 *   can be used in the project.    
 *
 * ============================================================================
 * PROVIDED AS-IS, NO WARRANTY OF ANY KIND, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * FREE TO SHARE, USE AND MODIFY UNDER TERMS: CREATIVE COMMONS - SHARE ALIKE
 * ============================================================================
*/


#include <`$INSTANCE_NAME`.h>


#define SYSTICK_INTERRUPT_VECTOR_NUMBER 15u // Cortex-M0 hard vector

//==============================================================================
// Interrupt on Cortex-M0 SysTick.
//==============================================================================

CY_ISR(SysTick_ISR)
{
    `$INSTANCE_NAME`_Reloads++;
}

//==============================================================================
// Initialize component
//==============================================================================

void `$INSTANCE_NAME`_Init() 
{
    CyIntSetSysVector(SYSTICK_INTERRUPT_VECTOR_NUMBER, SysTick_ISR); // point the Systick vector to the ISR
}



/* [] END OF FILE */

