/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#ifndef `$INSTANCE_NAME`_H
#define `$INSTANCE_NAME`_H

#include <cytypes.h> // uint8
      
    
#define true  1 // but not True
#define false 0 // but not False
    

    
// Variable declarations for DMA2
    // todo: `$INSTANCE_NAME`_
    uint8_t DMA_Chan;
    uint8_t DMA_TD[2]; 

/***************************************
*  Initialization Parameter Constants
***************************************/    
/***************************************
*           API Constants
***************************************/

#define `$INSTANCE_NAME`_NumSamples   (uint16) `=$num_samples               ` // number of sample points per period
#define `$INSTANCE_NAME`_NumRefHigh   (uint16) `=$num_sref_high            ` // number of samples when reference is high

//#define `$INSTANCE_NAME`_OutputType   (uint8)  `=$outp_type                ` // output type: 0: analog (voltage), 1: digital bus
    
    
#define `$INSTANCE_NAME`_RangeType    (uint16) `=$VDAC_Range               ` // 
#define `$INSTANCE_NAME`_SpeedType    (uint16) `=$VDAC_Speed               ` // 
#define `$INSTANCE_NAME`_StrobeMode            `=$strobe_mode`u                // external=1, register write = 0

//#define `$INSTANCE_NAME`_CONTROL_INP_B_API   `=($inp_B_ctrl == ctrl_API)` // use API to set B-value (multiplier)
#define `$INSTANCE_NAME`_SingleShot            `=$single_shot`                // continuous=0, single shot=1

#define `$INSTANCE_NAME`_TargetName            `=$DMA_target                ` // instance name of DMA target
#define `$INSTANCE_NAME`_TargetType            `=$DMA_target_type           ` // target type
    

   
/***************************************
*              Registers        
***************************************/    


  
//#define `$INSTANCE_NAME`_Data_PTR     `=$DMA_target`_COMPARE1_LSB_PTR    // PWM target pointer
//#define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`_Data_PTR             // VDAC8 target pointer
//#define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`_Data_PTR             // IDAC8 target pointer
//#define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`_Control_PTR             // ControlReg target pointer
//#define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`__DR                    // Pins_x8 target pointer
    
///#define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`_BUART_sTX_TxShifter_u0__D0_REG //-!ok
///#define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`_TXDATA_REG //-!ok
//#define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`_TXDATA_PTR 

#define CUST8   (0u)    
#define DAC8    (1u)
#define PWM8    (2u)
#define CREG8   (3u)
#define PORT8   (4u)
#define UART8   (5u)
#define TIMER8  (6u)
#define FILTER8 (7u)
    
    
    //todo: rename Target_PTR
/*    
#if   (`$INSTANCE_NAME`_TargetType == CUST8)
    #define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`                      // Custom target pointer
   
#elif (`$INSTANCE_NAME`_TargetType == DAC8)
    #define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`_Data_PTR             // IDAC8 target pointer

#elif (`$INSTANCE_NAME`_TargetType == PWM8)    
    #define `$INSTANCE_NAME`_Data_PTR     `=$DMA_target`_COMPARE1_LSB_PTR    // PWM target pointer

#elif (`$INSTANCE_NAME`_TargetType == CREG8)    
    #define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`_Control_PTR          // ControlReg target pointer

#elif (`$INSTANCE_NAME`_TargetType == PORT8)
    #define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`__DR                  // Pins_x8 target pointer

#elif (`$INSTANCE_NAME`_TargetType == UART8)
    #define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`_TXDATA_PTR           // UART target pointer

#elif (`$INSTANCE_NAME`_TargetType == TIMER8)
    #define `$INSTANCE_NAME`_Data_PTR    `=$DMA_target`_PERIOD_LSB_PTR       // Timer target pointer

#endif    
*/

#if   (`$INSTANCE_NAME`_TargetType == CUST8)
    #define `$INSTANCE_NAME`_Target_PTR    `=$DMA_target`                      // Custom target pointer
   
#elif (`$INSTANCE_NAME`_TargetType == DAC8)
    #define `$INSTANCE_NAME`_Target_PTR    `=$DMA_target`_Data_PTR             // IDAC8 target pointer

#elif (`$INSTANCE_NAME`_TargetType == PWM8)    
    #define `$INSTANCE_NAME`_Target_PTR     `=$DMA_target`_COMPARE1_LSB_PTR    // PWM target pointer

#elif (`$INSTANCE_NAME`_TargetType == CREG8)    
    #define `$INSTANCE_NAME`_Target_PTR    `=$DMA_target`_Control_PTR          // ControlReg target pointer

#elif (`$INSTANCE_NAME`_TargetType == PORT8)
    #define `$INSTANCE_NAME`_Target_PTR    `=$DMA_target`__DR                  // Pins_x8 target pointer

#elif (`$INSTANCE_NAME`_TargetType == UART8)
    #define `$INSTANCE_NAME`_Target_PTR    `=$DMA_target`_TXDATA_PTR           // UART target pointer

#elif (`$INSTANCE_NAME`_TargetType == TIMER8)
    #define `$INSTANCE_NAME`_Target_PTR    `=$DMA_target`_PERIOD_LSB_PTR       // Timer target pointer

#elif (`$INSTANCE_NAME`_TargetType == FILTER8)
    #define `$INSTANCE_NAME`_Target_PTR    `=$DMA_target`_STAGEAH_PTR          // Filter target pointer

#endif    


uint8_t `$INSTANCE_NAME`_Buffer[`$INSTANCE_NAME`_NumSamples];
//static uint8_t `$INSTANCE_NAME`_Buffer[`$INSTANCE_NAME`_NumSamples];//!ok
//uint8 * pBuffer = `$INSTANCE_NAME`_Buffer; 

//int8_t `$INSTANCE_NAME`_Buffer[`$INSTANCE_NAME`_NumSamples]; //signed


/***************************************
*        read-only variables
***************************************/  

// encapsulation->  
#define `$INSTANCE_NAME`_Enabled    `$INSTANCE_NAME`_GetEnabled()       // flag
#define `$INSTANCE_NAME`_BufState   `$INSTANCE_NAME`_GetBufferState()   // flag
#define `$INSTANCE_NAME`_BufOffset  `$INSTANCE_NAME`_GetBufferOffset()  // offset for half-buffer completed 
   



/***************************************
*        Function Prototypes
***************************************/

void  `$INSTANCE_NAME`_Start();                 // start
void  `$INSTANCE_NAME`_Stop();                  // stop
void  `$INSTANCE_NAME`_Disable();               // pause
void  `$INSTANCE_NAME`_Enable();                // resume
void  `$INSTANCE_NAME`_Reset();                // reset wave to start

void  `$INSTANCE_NAME`_DMAConfig(void);           // 
//void  `$INSTANCE_NAME`_DMAConfigEx(uint8 value);           //
//void  `$INSTANCE_NAME`_DMAConfigEx1(uint8 value);           //
//void  `$INSTANCE_NAME`_UpdateWave(uint8 ampl);           // 

//void  `$INSTANCE_NAME`_WriteB(uint8 value);    // set value for inpur B (multiplier)
//uint8 `$INSTANCE_NAME`_GetB();                 // return current multiplier value 



uint8  `$INSTANCE_NAME`_GetEnabled();            // getter for Enabled 
uint8  `$INSTANCE_NAME`_GetBufferState();        // getter for Buffer state: 1-first half (high), 0-second half (low) 
uint16 `$INSTANCE_NAME`_GetBufferOffset();       // getter for half-Buffer offset: 0-first half (high), NumRefHigh-second half (low) 


#endif

/* [] END OF FILE */

//void DMAConfig(void);
//void UpdateWave(uint8 ampl);
//uint8 UpdateWaveFreq(uint8 val);
//uint8 UpdateWavePhase(uint8 val);